class CalcEncoder:
	# ASCII to calculator equates
	t2x= [0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0xD6,\
			0x20,0x20,0xD6,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,\
			0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20,\
			0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B,\
			0x2C,0x2D,0x2E,0x2F,0x30,0x31,0x32,0x33,0x34,0x35,0x36,\
			0x37,0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,0x40,0x41,\
			0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4A,0x4B,0x4C,\
			0x4D,0x4E,0x4F,0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,\
			0x58,0x59,0x5A,0xC1,0x5C,0x5D,0x5E,0x5F,0x60,0x61,0x62,\
			0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6A,0x6B,0x6C,0x6D,\
			0x6E,0x6F,0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,\
			0x79,0x7A,0x7B,0x7C,0x7D,0x7E]
	# Character width - not used here, but it's handy to have if you need it.
	t2xw=[4,6,4,4,4,4,4,5,4,4,4,4,4,4,4,5,\
			4,5,4,4,5,5,4,5,6,5,4,4,5,6,4,4,\
			1,2,4,6,6,4,5,2,3,3,6,4,3,4,2,4,\
			4,4,4,4,4,4,4,4,4,4,2,3,4,4,4,4,\
			6,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,\
			4,4,4,4,4,4,4,4,4,4,4,4,4,3,4,4,\
			3,4,4,4,4,4,3,4,4,2,4,4,3,6,4,4,\
			4,4,4,3,3,4,4,6,4,4,5,4,2,4,5,4,\
			4,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,\
			4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,\
			4,4,4,4,4,4,3,3,4,4,2,5,4,5,6,4,\
			4,3,4,5,6,5,5,5,5,6,6,4,4,4,3,4,\
			4,4,3,4,4,4,4,4,4,4,4,4,4,4,5,3,\
			3,5,5,6,5,6,5,6,5,6,5,6,5,4,4,4,\
			4,4,6,6,5,4,4,4,4,4,4,4,4,4,4,4]
	# Calculator to ASCII equates
	x2t= [' ','n','u','v','w','>',' ','|','|','x','o','+','.','T',\
		  '3','F','/','-','2','/','o','r','T','<=','!=','>=','-',\
		  'E','>','10','[up]','[down]',' ','!','"','#','$','%','%',\
		  '\'','(',')','*','+',',','-','.','/','0','1','2','3','4',\
		  '5','6','7','8','9',':',';','<','=','>','?','@','A','B',\
		  'C','D','E','F','G','H','I','J','K','L','M','N','O','P',\
		  'Q','R','S','T','U','V','W','X','Y','Z','[theta]','\\',\
		  ']','^','_','`','a','b','c','d','e','f','g','h','i','j',\
		  'k','l','m','n','o','p','q','r','s','t','u','v','w','x',\
		  'y','z','{','|','}','~','=','0','1','2','3','4','5','6',\
		  '7','8','9','A','A','A','A','a','a','a','a','E','E','E',\
		  'E','e','e','e','e','I','I','I','I','i','i','i','i','O',\
		  'O','O','O','o','o','o','o','U','U','U','U','u','u','u',\
		  'u','C','c','N','n','\'','\'',':','?','!','a','B','g',\
		  'd','d','E','[','s','m','[pi]','p','E','o','T','o','Q',\
		  'x','y','x','_','<','o','/','-','2','o','3',"\r\n",'i',\
		  'p','x','F','e','L','N','a','E','O']

	# Encode ASCII into calculator-formatted strings
	def calcencode(self,input):
		#newlines
		#input = "\n".join(input)

		#character conversion
		input = ''.join([chr(0xD0) if ord(c)>=len(self.t2x) else \
			chr(self.t2x[ord(c)]) for c in input])
		return input

	# Decode calculator-formatted strings into ASCII
	def calcdecode(self,input):
		input = ''.join(['?' if ord(c) > len(self.x2t) else \
			self.x2t[ord(c)] for c in input])
		return input
