#!/usr/bin/python
#+--------------------------------------------+
#|      Sample gCn Bridge Skeleton Code       |
#|  Bridge Skeleton by Christopher Mitchell   |
#|  This Bridge by:                           |
#|  Bridge Name:                              |
#|  Bridge Hub Name (8 chrs max): ________    |
#+--------------------------------------------+

# Remove whichever of the following you do not need
import os.path
import urllib2
import urllib
import sys
import socket
import string
import sched, time
import threading
import random
import signal
import string
import re
import copy

from subprocess import *
from logging import *

#gcn info
GCNSERVER = "gcnhub.cemetech.net"
GCNPORT = 4295
GCNREMOTE = "HubName"
GCNLOCAL = GCNREMOTE
allcalcs = dict()

#scheduler
s=sched.scheduler(time.time, time.sleep)
gcnlock = threading.Lock()

#global variables
gcnlock = threading.Lock()

def outtoclient(type,seq,contents,sid):
	gcnlock.acquire()
	msgindex = 0;
	thisoutmsg = chr(type) + chr(seq) + contents
	outmsghdr = chr(0xAA)+chr(0xAA)+chr(0xAA)+chr(0xAA)+chr(0xAA)+\
	            chr(len(thisoutmsg)&0x00ff)+chr((len(thisoutmsg)>>8)&0x00ff)
	outmsghdr = outmsghdr + thisoutmsg
	log_info("Forwarding '"+outmsghdr+"' to '"+calc5to10(sid)+"'")
	thismsg = chr(255)+chr(137)+sid+outmsghdr+chr(42)
	thismsg = chr(len(thismsg)&0x00ff)+chr((len(thismsg)>>8)&0x00ff)+\
	          'f'+thismsg
	clientsocket.sendall(thismsg)
	gcnlock.release()

def start():
	gcnthr = gCnManage()
	log_info('Starting gCn manager')
	gcnthr.start()
	log_info('gCn manager started.')

class gCnManage(threading.Thread):
        def __init__(self):
                threading.Thread.__init__(self)

        def run(self):
		global GCNSERVER
		global GCNPORT
		global GCNLOCAL
		global GCNREMOTE
		global clientsocket
		global client
		global allcalcs

		#create an INET, STREAMing socket
		log_info('starting gCn client')
		clientsocket = socket.socket(
		    socket.AF_INET, socket.SOCK_STREAM)
		#bind the socket to a public host,
		# and a well-known port
		clientsocket.connect((GCNSERVER,GCNPORT))

		#gCn join
		joinmsg = chr(2+len(GCNREMOTE)+len(GCNLOCAL))+chr(0)+'j'+\
		          chr(len(GCNREMOTE))+GCNREMOTE+\
				  chr(len(GCNLOCAL))+GCNLOCAL
		clientsocket.sendall(joinmsg)
		time.sleep(0.1);

		#gCn "calculator" join
		calcmsg = chr(10)+chr(0)+"cAAAAAAAAAA"
		clientsocket.sendall(calcmsg)
		time.sleep(0.1);

		recbuf = "";
		recbufqueue = 0;
		while 1==1:
			instring = clientsocket.recv(1024)
			recbuf = recbuf + instring
			recbufqueue += len(instring)
			while recbufqueue > 2 and recbufqueue >= 3+ord(recbuf[0])+256*ord(recbuf[1]):
				thismsglen = ord(recbuf[0])+256*ord(recbuf[1])
				thismsgtype = recbuf[2]
				thismsg = recbuf[3:3+thismsglen]
				if thismsgtype != 'f' and thismsgtype != 'b':
					log_warn("Unknown incoming msg type '"+thismsgtype+"'!")
					#continue;
				else:
					calc5 = thismsg[7:12]
					
					# Message body is in thismsg[14:]
					# TODO: Handle incoming messages here
					log_info("Received: "+thismsg[14:])
					

					recbuf = recbuf[3+thismsglen:]
				recbufqueue -= 3+thismsglen
				if recbufqueue != len(recbuf):
					log_error("buffer length mismatch, discarding buffer")
					recbuf = ""
					recbufqueue = 0

# Utility function: convert a 16-bit word into a little-endian byte string
def lestringify(innum):
	return chr(innum&0x00ff)+chr((innum>>8)&0x00ff)

# Convert a 5-byte calculator ID into an ASCII ID string
def calc5to10(calc5):
	return "%02X%02X%02X%02X%02X" % (ord(calc5[0]), ord(calc5[1]),
	       ord(calc5[2]), ord(calc5[3]), ord(calc5[4]))

# Return the ASCII-readable prefix of a byte strings
def cleanstr(instr):
	outstr = ""
	for i in range(0,len(instr)-1):
		if ord(instr[i]) <= 0:
			break;
		outstr += instr[i]
	return outstr

# Start this bridge!
if __name__ == '__main__':
	start()
